#pragma semicolon 1
#pragma tabsize 0

#include <sourcemod>
#include <sdktools>
#include <colors>

#define EFFECT2      "effects/combinemuzzle2.vmt"
#define EFFECT1      "effects/combinemuzzle1.vmt"

new g_kills[MAXPLAYERS+1]={0,...};
new g_list[65][3][2];
new String: weaponlist[][] = { "hegrenade", "flashbang", "smokegrenade" };
new neededlist[3] = {3,5,2}; //needed kills to get another item of the type listed above
new nademode = 0;
new me_enable = 1;
new ffa = 0;
new g_OffsetMovement;
new g_iHealth;
new g_ArmorValue;
new HsAdd = 10;
new HgAdd = 10;
new HkAdd = 20;
new HpAdd = 5;
new MaxHp = 110;
new AsAdd = 5;
new AgAdd = 5;
new AkAdd = 10;
new ArAdd = 2;
new MaxAr = 110;
new Announce = 1;
new BonusSpeed_Kill = 5;
new g_Ent_Effect[MAXPLAYERS+1] = {-1, ...};
new g_EffectType = 1;

new Float:BonusSpeed = 1.5;
new Float:BonusTime = 10.0;

new Handle:Client_ClearTime[65] = INVALID_HANDLE;

new Handle:cv_Enabled;
new Handle:cv_ffa; 
new Handle:cv_HsAdd;
new Handle:cv_HgAdd;
new Handle:cv_HkAdd;
new Handle:cv_HpAdd;
new Handle:cv_MaxHp;
new Handle:cv_AsAdd;
new Handle:cv_AgAdd;
new Handle:cv_AkAdd;
new Handle:cv_ArAdd;
new Handle:cv_MaxAr;
new Handle:cv_Announce;
new Handle:cv_BonusSpeed_kill;
new Handle:cv_EffectType;
new Handle:cv_BonusSpeed;
new Handle:cv_BonusTime;
new Handle:cv_needed_HE;
new Handle:cv_needed_flash;
new Handle:cv_needed_smoke;
new Handle:cv_nademode;

#define PLUGIN_VERSION "1.0.5.3"

public Plugin:myinfo =  
{ 
	name = "Kill Bonus", 
	author = "", 
	description = "Gives someone Hp, Armor & Grenade on a kill", 
	version = PLUGIN_VERSION, 
	url = "www.hlmod.ru" 
} 

public OnPluginStart() 
{ 
	CreateConVar("kb_version", PLUGIN_VERSION, "Kill Bonus Version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);

	cv_Enabled  =	 CreateConVar("kb_enabled",     "1",   "Enables - Disables the Kill bonus plugin", FCVAR_NOTIFY);
	cv_ffa 	 	=	 CreateConVar("kb_ffa",     	"0",   "Enables - Disables ffa", FCVAR_NOTIFY);
	cv_HsAdd    =    CreateConVar("kb_Hp_headshot",    "10",  "value # equals the amount of hp to add, when attacker headshots", FCVAR_NOTIFY); 
	cv_HgAdd    =    CreateConVar("kb_Hp_hegrenade",   "10",  "value # equals the amount of hp to add, when attacker hegrenade", FCVAR_NOTIFY);
	cv_HkAdd    =    CreateConVar("kb_Hp_knife",       "20",  "value # equals the amount of hp to add, when attacker knife", FCVAR_NOTIFY); 
	cv_HpAdd    =    CreateConVar("kb_hp",          "5",   "value # equals the amount of hp to add, when the someone kills someone", FCVAR_NOTIFY); 
	cv_MaxHp    =    CreateConVar("kb_MaxHp",       "110", "value # equals the max hp that the attacker could get", FCVAR_NOTIFY);
	cv_AsAdd    =    CreateConVar("kb_Ar_headshot",    "5",   "value # equals the amount of Armor to add, when attacker headshots", FCVAR_NOTIFY); 
	cv_AgAdd    =    CreateConVar("kb_Ar_hegrenade",   "5",   "value # equals the amount of Armor to add, when attacker hegrenade", FCVAR_NOTIFY);
	cv_AkAdd    =    CreateConVar("kb_Ar_knife",       "10",  "value # equals the amount of Armor to add, when attacker knife", FCVAR_NOTIFY); 
	cv_ArAdd    =    CreateConVar("kb_Ar",          "2",   "value # equals the amount of Armor to add, when the someone kills someone", FCVAR_NOTIFY); 
	cv_MaxAr    =    CreateConVar("kb_MaxAr",       "110", "value # equals the max Armor that the attacker could get", FCVAR_NOTIFY);
	cv_needed_HE =   CreateConVar("kb_needed_HE",   "3",   "Kills needed to recieve hegrenade, 0 = disable", FCVAR_NOTIFY);
	cv_needed_flash = CreateConVar("kb_needed_flash", "5", "Kills needed to recieve flashbang, 0 = disable", FCVAR_NOTIFY);
	cv_needed_smoke = CreateConVar("kb_needed_smoke", "2", "Kills needed to recieve smokegrenade, 0 = disable", FCVAR_NOTIFY);
	cv_nademode =     CreateConVar("kb_nademode",     "0", "0 = replenish used nades only, 1 = always give nade /n(useful in conjunction with SM plugin 'Grenade Pack')", FCVAR_NOTIFY);
	cv_Announce  =    CreateConVar("kb_announce",     "1", "Enables - Disables announce", FCVAR_NOTIFY);
	cv_BonusSpeed_kill = CreateConVar("kb_BonusSpeed_kill",   "5", "Bonus speed kill, 0 = disable", FCVAR_NOTIFY); 
	cv_BonusSpeed   =    CreateConVar("kb_BonusSpeed",  "1.5", "Bonus speed", FCVAR_NOTIFY); 
	cv_BonusTime  =    CreateConVar("kb_BonusTime",     "10.0", "Bonus speed time", FCVAR_NOTIFY);
	cv_EffectType  =    CreateConVar("kb_EffectType",     "1", "Effect Type, 0 = disable", FCVAR_NOTIFY);

	if(me_enable)
	{
		HookEvent("player_death", Event_PlayerDeath);
		HookEvent("round_start", Event_RoundStart);
		HookEvent("player_spawn", Event_PlayerSpawn);
		HookEvent("weapon_fire", EventWeaponFire);
	}
	
	g_OffsetMovement = FindSendPropOffs("CBasePlayer", "m_flLaggedMovementValue");
	if (g_OffsetMovement == -1)
		SetFailState("[Kill Bonus] Unable to get offset for CBasePlayer::m_flLaggedMovementValue.");
		
	g_iHealth = FindSendPropOffs("CCSPlayer", "m_iHealth");
	if (g_iHealth == -1)
		SetFailState("[Kill Bonus]: Unable to get offset for CSSPlayer::m_iHealth");
		
	g_ArmorValue = FindSendPropOffs("CCSPlayer", "m_ArmorValue");
	if (g_ArmorValue == -1)
		SetFailState("[Kill Bonus]: Unable to get offset for CSSPlayer::m_ArmorValue");

	LoadTranslations("plugin.killbonus");

	HsAdd = GetConVarInt(cv_HsAdd);
	HgAdd = GetConVarInt(cv_HgAdd);
	HkAdd = GetConVarInt(cv_HkAdd);
	HpAdd = GetConVarInt(cv_HpAdd);
	MaxHp = GetConVarInt(cv_MaxHp);
	AsAdd = GetConVarInt(cv_AsAdd);
	AgAdd = GetConVarInt(cv_AgAdd);
	AkAdd = GetConVarInt(cv_AkAdd);
	ArAdd = GetConVarInt(cv_ArAdd);
	MaxAr = GetConVarInt(cv_MaxAr);
	g_EffectType = GetConVarInt(cv_EffectType);
	BonusSpeed_Kill = GetConVarInt(cv_BonusSpeed_kill);
	BonusTime = GetConVarFloat(cv_BonusTime);
	BonusSpeed = GetConVarFloat(cv_BonusSpeed);
	nademode = GetConVarInt(cv_nademode);
	Announce = GetConVarInt(cv_Announce);
	neededlist[0] = GetConVarInt(cv_needed_HE);
	neededlist[1] = GetConVarInt(cv_needed_flash);
	neededlist[2] = GetConVarInt(cv_needed_smoke);
	me_enable = GetConVarInt(cv_Enabled);
	ffa = GetConVarInt(cv_ffa);

	AutoExecConfig(true, "Kill_Bonus");
}

public OnMapStart() 
{
    PrecacheModel(EFFECT2);
    PrecacheModel(EFFECT1);
}

public OnConfigsExecuted()
{
	me_enable = GetConVarInt(cv_Enabled);
	ffa = GetConVarInt(cv_ffa);
	HsAdd = GetConVarInt(cv_HsAdd);
	HgAdd = GetConVarInt(cv_HgAdd);
	HkAdd = GetConVarInt(cv_HkAdd);
	HpAdd = GetConVarInt(cv_HpAdd);
	MaxHp = GetConVarInt(cv_MaxHp);
	AsAdd = GetConVarInt(cv_AsAdd);
	AgAdd = GetConVarInt(cv_AgAdd);
	AkAdd = GetConVarInt(cv_AkAdd);
	ArAdd = GetConVarInt(cv_ArAdd);
	MaxAr = GetConVarInt(cv_MaxAr);
	g_EffectType = GetConVarInt(cv_EffectType);
	BonusSpeed_Kill = GetConVarInt(cv_BonusSpeed_kill);
	BonusTime = GetConVarFloat(cv_BonusTime);
	BonusSpeed = GetConVarFloat(cv_BonusSpeed);
	nademode = GetConVarInt(cv_nademode);
	Announce = GetConVarInt(cv_Announce);
	neededlist[0] = GetConVarInt(cv_needed_HE);
	neededlist[1] = GetConVarInt(cv_needed_flash);
	neededlist[2] = GetConVarInt(cv_needed_smoke);
}

get_weapon_index(const String: weapon_name[])
{
	new loop_break = 0;
	new index = 0;
	
	while ((loop_break == 0) && (index < sizeof(weaponlist)))
	{
		if (strcmp(weapon_name, weaponlist[index], true) == 0)
			loop_break++;
		index++;
	}

	if (loop_break == 0)
		return -1;
	else
		return index - 1;
}

public Action:EventWeaponFire(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (me_enable == 0 || nademode == 1)
		return Plugin_Continue;
	
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if (client < 1)
		return Plugin_Continue;
	
	new String:weapon[64];
	GetEventString(event, "weapon", weapon, 64);
	new weapon_index = get_weapon_index(weapon);
	if (weapon_index == -1)
		return Plugin_Continue;

	g_list[client][weapon_index][0]++;
	
	return Plugin_Continue;
}

public EnableChanged(Handle:convar, const String:oldValue[], const String:newValue[])
{
	new iNew = StringToInt(newValue);
	new iOld = StringToInt(oldValue);
	if (iNew == iOld)
		return;
	if (iNew == 1)
	{
		me_enable = 1;
		ResetAll();
	}
	else
		me_enable = 0;
}
public OnClientPutInServer(client)
{
	if(me_enable == 0)
		return;
	
	ResetClient(client);
	Client_ClearTime[client] = INVALID_HANDLE;	
}
public OnClientDisconnect(client)
{
	if(me_enable == 0)
		return;
	
	ResetClient(client);
	if (IsClientInGame(client) && IsPlayerAlive(client))
    {
        StopEffectClient(client);
    }
}
ResetAll()
{
	for (new i = 1; i <= MaxClients; i++)
	{
		ResetClient(i);
	}
}
ResetClient(client)
{
	for (new j = 0; j < 3; j++)
	{
		g_list[client][j][0] = 0;
		g_list[client][j][1] = 0;
	}
	g_kills[client] = 0;
}

public Event_RoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(me_enable == 0)
		return;
	
	ResetAll();
}
public Event_PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(GetClientTeam(client) < 2)
		return;

	if(me_enable == 0)
		return;
	
	ResetClient(client);
}

public Event_PlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	new victim = GetClientOfUserId(GetEventInt(event, "userid"));
	new attacker =  GetClientOfUserId(GetEventInt(event, "attacker"));

	if(attacker == 0)
	{
		return;
	}

	new CurrentHp    = GetClientHealth(attacker);
	new CurrentAr    = GetClientArmor(attacker);

	new bool:headshot = GetEventBool(event, "headshot");
    
	new String:Weapon[64];
	GetEventString(event, "weapon", Weapon, sizeof(Weapon));
	
	if(!ffa)
	{
		new team_victim = GetClientTeam(victim);
		new team_attacker = GetClientTeam(attacker);
		new bool:teamkill = (team_victim == team_attacker);

		ResetClient(victim);
	
		if(attacker == victim || teamkill)
		{
			return;
		}	
	}


	if(!strcmp(Weapon, "hegrenade", false))
	{
		if((CurrentHp + HgAdd) > MaxHp||(CurrentAr + AgAdd) > MaxAr)
		{        
			SetEntProp(attacker, Prop_Send, "m_iHealth", MaxHp);
			SetEntProp(attacker, Prop_Send, "m_ArmorValue", MaxAr);
			
			if (Announce)
				CPrintToChat(attacker, "%t", "hegrenadeHpAr", MaxHp - CurrentHp, MaxAr - CurrentAr);
		} 
		else 
		{
			SetEntProp(attacker, Prop_Send, "m_iHealth", HgAdd + CurrentHp);
			SetEntProp(attacker, Prop_Send, "m_ArmorValue", AgAdd + CurrentAr);
			
			if (Announce)
				CPrintToChat(attacker, "%t", "hegrenadeHpAr", HgAdd, AgAdd);
		}
	}
	
	else if(!strcmp(Weapon, "knife", false))
	{
		if((CurrentHp + HkAdd) > MaxHp||(CurrentAr + AkAdd) > MaxAr)
        {        
			SetEntProp(attacker, Prop_Send, "m_iHealth", MaxHp);
			SetEntProp(attacker, Prop_Send, "m_ArmorValue", MaxAr);
			
			if (Announce)
				CPrintToChat(attacker, "%t", "knifeHpAr", MaxHp - CurrentHp, MaxAr - CurrentAr);    
		} 
		else
		{
			SetEntProp(attacker, Prop_Send, "m_iHealth", HkAdd + CurrentHp);
			SetEntProp(attacker, Prop_Send, "m_ArmorValue", AkAdd + CurrentAr);
			
			if (Announce)
				CPrintToChat(attacker, "%t", "knifeHpAr", HkAdd, AkAdd);
		}
	}

	else if(headshot)
	{
		if((CurrentHp + HsAdd) > MaxHp||(CurrentAr + AsAdd) > MaxAr)
		{        
			SetEntProp(attacker, Prop_Send, "m_iHealth", MaxHp);
			SetEntProp(attacker, Prop_Send, "m_ArmorValue", MaxAr);
			
			if (Announce)
                CPrintToChat(attacker, "%t", "headshotHpAr", MaxHp - CurrentHp, MaxAr - CurrentAr);
		} 
		else 
        {
			SetEntProp(attacker, Prop_Send, "m_iHealth", HsAdd + CurrentHp);
			SetEntProp(attacker, Prop_Send, "m_ArmorValue", AsAdd + CurrentAr);
			
			if (Announce)
				CPrintToChat(attacker, "%t", "headshotHpAr", HsAdd, AsAdd);
		}
	}
	else
    {
		if((CurrentHp + HpAdd) > MaxHp||(CurrentAr + ArAdd) > MaxAr)
		{        
			SetEntProp(attacker, Prop_Send, "m_iHealth", MaxHp);
			SetEntProp(attacker, Prop_Send, "m_ArmorValue", MaxAr);
			
			if (Announce)
				CPrintToChat(attacker, "%t", "killHpAr", MaxHp - CurrentHp, MaxAr - CurrentAr);
		} 
		else 
		{
			SetEntProp(attacker, Prop_Send, "m_iHealth", HpAdd + CurrentHp);
			SetEntProp(attacker, Prop_Send, "m_ArmorValue", ArAdd + CurrentAr);
			
			if (Announce)
				CPrintToChat(attacker, "%t", "killHpAr", HpAdd, ArAdd);
        }    
    }

	new client   = attacker;
	g_kills[victim] = 0;
	g_kills[attacker]++;
	
	for (new j = 0; j < 3; j++)
	{
		if(neededlist[j] == 0)
			continue;
		
		g_list[client][j][1]++;
		
		if(g_list[client][j][1] >= neededlist[j])
		{
			if((g_list[client][j][0] > 0 && nademode == 0) || nademode == 1)
			{
				g_list[client][j][1] = 0;
				if(nademode == 0)
					g_list[client][j][0]--;
				new String:ent_weapon[64];
				
				Format(ent_weapon, sizeof(ent_weapon), "weapon_%s", weaponlist[j]);
				GivePlayerItem(attacker, ent_weapon);
				
				if (Announce)
					CPrintToChat(attacker, "%t", "Giving_Grenade", weaponlist[j]);
			}
		}
	}

	if(BonusSpeed_Kill && (g_kills[attacker] >= BonusSpeed_Kill) && !(g_kills[attacker]%BonusSpeed_Kill))
	{
		new Time     = GetConVarInt(cv_BonusTime);

		SetEntDataFloat(client, g_OffsetMovement, BonusSpeed);
		StartEffectClient(client);
		
		ExCloseHandle(Client_ClearTime[client]);
		Client_ClearTime[client] = CreateTimer(BonusTime, RemoveBonus, client);
		
		if (Announce)
			CPrintToChat(attacker, "%t", "Bonus_speed", Time);
	}
	
	if (IsPlayerAlive(client))
	{
		StopEffectClient(victim);
	}
}

stock ExCloseHandle(&Handle:handle)
{
	if(handle != INVALID_HANDLE)
		CloseHandle(handle);
	handle = INVALID_HANDLE;
}

public Action:RemoveBonus(Handle:timer, any:client)
{
	if (IsClientInGame(client))
	{
		StopBonus(client);
		StopEffectClient(client);
	}

	Client_ClearTime[client] = INVALID_HANDLE;	
	return Plugin_Stop;
}

StopBonus(client)
{
	if(BonusSpeed)
	{
		SetEntDataFloat(client, g_OffsetMovement, 1.0);
	}
}


StartEffectClient(client) 
{
    if (g_Ent_Effect[client]  > -1) 
	{
        return 0;
    }
    g_Ent_Effect[client] = CreateEffect(client);
    return 1;
}

CreateEffect(client) 
{
    if (!IsClientInGame(client)) 
	{
        return -1;
    }

	switch (g_EffectType)
	{
		case 0:
		{
			return -1;
		}
		case 1:
		{
			return CreateEffect1(client);
		}
		case 2:
		{
			return CreateEffect2(client);
		}
    }
	
	return -1;
}

StopEffectClient(client) 
{
    if (g_Ent_Effect[client] < 0) 
	{
        return;
    }
    if (IsValidEdict(g_Ent_Effect[client])) 
	{
        switch (g_EffectType)
		{
			case 0:
			{
				return;
			}
			case 1:
			{
				StopEffect1(client);
			}
			case 2:
			{
				StopEffect2(client);
			}
		}
    }
    g_Ent_Effect[client] = -1;
}

StopEffect1(client) 
{
    RemoveEdict(g_Ent_Effect[client]);
}

StopEffect2(client) 
{
    AcceptEntityInput( g_Ent_Effect[client], "TurnOff" );
    AcceptEntityInput( g_Ent_Effect[client], "Kill" );
}

CreateEffect1(client) 
{
    new ent = CreateEntityByName("env_spritetrail");
    new String:target[32];
    Format(target, sizeof(target), "target%i", client);
     
    DispatchKeyValue(client, "targetname", target);
    DispatchKeyValue(ent, "parentname", target);
    DispatchKeyValue(ent, "lifetime", "1.0");
    DispatchKeyValue(ent, "endwidth", "1.0");
    DispatchKeyValue(ent, "startwidth", "20.0");
    //DispatchKeyValue(ent, "spritename", "materials/sprites/bluelaser1.vmt");
    DispatchKeyValue(ent, "spritename", "materials/sprites/crystal_beam1.vmt");
    DispatchKeyValue(ent, "renderamt", "255");
    //DispatchKeyValue(ent, "rendercolor", "0 128 255");
    DispatchKeyValue(ent, "rendercolor", "255 128 0");
    DispatchKeyValue(ent, "rendermode", "5");
    
    DispatchSpawn(ent);
    
    new Float:Client_Origin[3];
    GetClientAbsOrigin(client,Client_Origin);
    Client_Origin[2] += 20.0; //Beam clips into the floor without this
    TeleportEntity(ent, Client_Origin, NULL_VECTOR, NULL_VECTOR);
    
    SetVariantString(target);
    AcceptEntityInput(ent, "SetParent");
    return ent;
}

CreateEffect2(client) 
{
    new particle = CreateEntityByName("env_smokestack");
    if (!IsValidEdict(particle)) 
	{
        LogError( "Failed to create env_smokestack (%i) for client %i!", particle, client );
        return -1;
    }

    decl String:Name[32], Float:fPos[3], Float:fAng[3] = { 0.0, 0.0, 0.0 };
    Format( Name, sizeof( Name ), "CSParticle_%i", client );
    GetEntPropVector( client, Prop_Send, "m_vecOrigin", fPos );
    fPos[2] += 28;

    //Set Key Values
    DispatchKeyValueVector( particle, "Origin", fPos );
    DispatchKeyValueVector( particle, "Angles", fAng );
    DispatchKeyValueFloat( particle, "BaseSpread", 15.0 );
    DispatchKeyValueFloat( particle, "StartSize", 2.0 );
    DispatchKeyValueFloat( particle, "EndSize", 6.0 );
    DispatchKeyValueFloat( particle, "Twist", 0.0 );
    
    DispatchKeyValue( particle, "Name", Name );
    DispatchKeyValue( particle, "SmokeMaterial", EFFECT2 );
    DispatchKeyValue( particle, "RenderColor", "252 232 131" );
    DispatchKeyValue( particle, "SpreadSpeed", "10" );
    DispatchKeyValue( particle, "RenderAmt", "200" );
    DispatchKeyValue( particle, "JetLength", "13" );
    DispatchKeyValue( particle, "RenderMode", "0" );
    DispatchKeyValue( particle, "Initial", "0" );
    DispatchKeyValue( particle, "Speed", "10" );
    DispatchKeyValue( particle, "Rate", "173" );
    DispatchSpawn( particle );

    //Set Entity Inputs
    SetVariantString( "!activator" );
    AcceptEntityInput( particle, "SetParent", client, particle, 0 );
    AcceptEntityInput( particle, "TurnOn" );
    return particle;
}